// vi: set ts=2 shiftwidth=2 expandtab:
//
// VNPForth - Compiled native Forth for IA32 Linux systems
// Copyright (C) 2005  Simon Baldwin (simon_baldwin@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

#ifndef _VNPFORTH_COMMANDLINE_H
#define _VNPFORTH_COMMANDLINE_H

#include <string>
#include <vector>

#include "options.h"

// Command line options and arguments.
class CommandLine
{
public:
  CommandLine (int argc,
               char * const * argv);

  Options get_options () const;
  std::string get_program_name () const;
  std::vector<std::string> get_arguments () const;

private:
  Options options_;

  std::string program_name_;
  std::vector<std::string> arguments_;

  void usage ();
  void version ();
  void help ();
};

// Inline function definitions.
inline Options
CommandLine::get_options () const
{
  return options_;
}

inline std::string
CommandLine::get_program_name () const
{
  return program_name_;
}

inline std::vector<std::string>
CommandLine::get_arguments () const
{
  return arguments_;
}

#endif
