// vi: set ts=2 shiftwidth=2 expandtab:
//
// VNPForth - Compiled native Forth for IA32 Linux systems
// Copyright (C) 2005  Simon Baldwin (simon_baldwin@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

#ifndef _VNPFORTH_MANGLER_H
#define _VNPFORTH_MANGLER_H

#include <string>
#include <map>

// Mangler strategy, creates a linker-safe name string for a Forth symbol.
class Mangler {
public:
  static const std::string mangle (const std::string & s);

private:
  Mangler ();

  typedef std::map<char, const char *, std::less<char> > EntityTable;
  typedef EntityTable::iterator EntityTableIterator;

  static void initialize ();
  static EntityTable entities_table;
};

#endif
