// vi: set ts=2 shiftwidth=2 expandtab:
//
// VNPForth - Compiled native Forth for IA32 Linux systems
// Copyright (C) 2005  Simon Baldwin (simon_baldwin@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//

#ifndef _VNPFORTH_UTIL_H
#define _VNPFORTH_UTIL_H

#include <string>
#include <sstream>
#include <iostream>

namespace {

// General purpose string converter.
template <class C>
  const std::string
  to_string (C x)
  {
    std::ostringstream outs;
    outs << x;
    return outs.str ();
  }

// gcc 2.95.3 has a bug in it that causes it to ignore field widths for
// string output; this works around the bug.
std::ostream &
operator<< (std::ostream & outs,
            const std::string & s)
{
  outs << s.c_str ();
  return outs;
}

// Stand-in left and right justification manipulators.
std::ostream &
leftjustify (std::ostream & outs)
{
  outs.setf (std::ios::left);
  return outs;
}
std::ostream &
rightjustify (std::ostream & outs)
{
  outs.setf (std::ios::right);
  return outs;
}

}

#endif
