/* vi: set ts=8 shiftwidth=8 expandtab:
 *
 * VNPForth demonstration program.
 *
 * This module is the main module for a call to pi.ft.  The program
 * demonstrates calling Forth words from C.
 *
 * The program prints out a simple estimate of Pi.
 */

#include <stdio.h>
#include "forthlib.h"

extern void     ITERATE_MinusPI (void);         /* Forth ITERATE-PI */

int main (int argc, char **argv) {
        union {
                float   f;
                int     i;
        } fi_union;

        /* Set up the Forth stacks for ( 23 -- ) ( F: 3.0 -- ) */
        fdpush (23);                            /* push 23 onto data stack */
        fi_union.f = 3.0;
        fdpush (fi_union.i);                    /* push 3.0 onto data stack */
        GreaterF ();                            /* >F */

        /* Call the Forth iteration function. */
        ITERATE_MinusPI ();

        /* Retrieve the top of Forth stack value. */
        F_Greater ();                           /* F> */
        fi_union.i = fdpop ();                  /* pop data stack into i */

        /* Print the result. */
        printf ("Pi calculated as %9.8f\n", fi_union.f);

        return 0;
}
