#!/bin/awk -f
# vi: set ts=2 shiftwidth=2 expandtab:
#
# VNPForth - Compiled native Forth for IA32 Linux systems
# Copyright (C) 2005  Simon Baldwin (simon_baldwin@yahoo.com)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
#
# AWK script to produce variable and word name list from processed
# Forth source.
#

# Initialize the states, arrays, and indices.
BEGIN {
  IDLE                    = 0
  VARIABLE_NAME           = 1
  VARIABLE_SIZE           = 2
  WORD_NAME               = 3
  VARIABLE_DESCRIPTION    = 4
  WORD_DESCRIPTION        = 5
  state                   = IDLE

  VARIABLE_TAG            = "V"
  VARIABLE_SIZETAG        = "B"
  WORD_TAG                = "W"
  STACKDOCUMENTATION_TAG  = "S"
  DOCUMENTATION_TAG       = "D"
  END_TAG                 = "E"

  C_INTARRAY              = 0
  C_CHARARRAY             = 1
}

# Find either a variable or a word tag, and write out the name.
$1 == VARIABLE_TAG || $1 == WORD_TAG {

  # Print the Forth name, and we are done.
  printf ("%s\n", $2)
}
